
Redmine - Patch #28939

replace regexp with casecmp

2018-06-04 00:46 - Pavel Rosický

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version:    

Description

require 'benchmark/ips'

Benchmark.ips do |x|

  x.report('casecmp') { 'PostgreSql'.casecmp('postgresql') == 0 }

  x.report('match')   { 'PostgreSql' =~ /postgresql/i }

  x.report('match?')  { 'PostgreSql'.match? /postgresql/i }

  x.compare!

end

 
Comparsion:

casecmp:  4218477.8 i/s

 match?:  3025829.3 i/s - 1.39x  slower

  match:  2222223.1 i/s - 1.90x  slower

Related issues:

Related to Redmine - Patch #28940: Use Regexp#match? to reduce allocations of... Closed

History

#1 - 2018-06-04 00:49 - Pavel Rosický

- File nested_set.patch added

#2 - 2018-06-04 01:44 - Go MAEDA

The proposed patch does not work for MySQL adapter because its name is "Mysql2". I think using exact match against adapter names is not a good

solution.

irb(main):001:0> ActiveRecord::Base.connection.adapter_name

=> "Mysql2" 

#3 - 2018-06-04 02:19 - Pavel Rosický

- Status changed from New to Resolved

ah, sorry. I totaly forgot about this case. I used match? insted in

http://www.redmine.org/issues/28940

so the behaviour won't be changed. Closing this one

#4 - 2018-06-04 03:28 - Go MAEDA

- Related to Patch #28940: Use Regexp#match? to reduce allocations of MatchData object added

#5 - 2018-06-04 03:31 - Go MAEDA

- Status changed from Resolved to Closed

Pavel Rosický wrote:

I used match? insted in

http://www.redmine.org/issues/28940

 Closing this issue because #28940 covers this improvement. Thank you.
database.rb.patch 840 Bytes 2018-06-03 Pavel Rosický

nested_set.patch 1.02 KB 2018-06-03 Pavel Rosický
